﻿using System;
using Foundation;
using ObjCRuntime;
using UIKit;

namespace DriverLicenseParser
{
	// @interface DriverLicense : NSObject
	[BaseType (typeof(NSObject))]
	interface DriverLicense
	{
		// -(BOOL)parseDLString:(NSString *)inputString hideSerialAlert:(BOOL)hideSerialAlert;
		[Export ("parseDLString:hideSerialAlert:")]
		bool ParseDLString (string inputString, bool hideSerialAlert);

		// +(NSString *)dlpUniqueId;
		[Static]
		[Export ("dlpUniqueId")]
		//[Verify (MethodToProperty)]
		string DlpUniqueId { get; }

		// -(id)initWithInput:(NSString *)tracksString parseSucced:(BOOL **)success hideSerialAlert:(BOOL)hideSerialAlert;
		[Export ("initWithInput:parseSucced:hideSerialAlert:")]
		unsafe IntPtr Constructor (string tracksString, bool success, bool hideSerialAlert);

		// @property (retain, nonatomic) NSString * countryCode;
		[Export ("countryCode", ArgumentSemantic.Retain)]
		string CountryCode { get; set; }

		// @property (readonly, retain, nonatomic) NSString * documentType;
		[Export ("documentType", ArgumentSemantic.Retain)]
		string DocumentType { get; }

		// @property (retain, nonatomic) NSDictionary * raw_parsed_fields;
		[Export ("raw_parsed_fields", ArgumentSemantic.Retain)]
		NSDictionary Raw_parsed_fields { get; set; }

		// @property (retain, nonatomic) NSString * specification;
		[Export ("specification", ArgumentSemantic.Retain)]
		string Specification { get; set; }

		// @property (retain, nonatomic) NSString * parserName;
		[Export ("parserName", ArgumentSemantic.Retain)]
		string ParserName { get; set; }

		// @property (readonly, retain, nonatomic) NSDictionary * fields;
		[Export ("fields", ArgumentSemantic.Retain)]
		NSDictionary Fields { get; }

		// @property (readonly, retain, nonatomic) NSString * licenseNumber;
		[Export ("licenseNumber", ArgumentSemantic.Retain)]
		string LicenseNumber { get; }

		// @property (readonly, retain, nonatomic) NSString * expirationDate;
		[Export ("expirationDate", ArgumentSemantic.Retain)]
		string ExpirationDate { get; }

		// @property (retain, nonatomic) NSString * IIN;
		[Export ("IIN", ArgumentSemantic.Retain)]
		string IIN { get; set; }

		// @property (readonly, retain, nonatomic) NSString * issuerIdNum;
		[Export ("issuerIdNum", ArgumentSemantic.Retain)]
		string IssuerIdNum { get; }

		// @property (readonly, retain, nonatomic) NSString * issuedBy;
		[Export ("issuedBy", ArgumentSemantic.Retain)]
		string IssuedBy { get; }

		// @property (readonly, retain, nonatomic) NSString * endorsementsCode;
		[Export ("endorsementsCode", ArgumentSemantic.Retain)]
		string EndorsementsCode { get; }

		// @property (readonly, retain, nonatomic) NSString * classificationCode;
		[Export ("classificationCode", ArgumentSemantic.Retain)]
		string ClassificationCode { get; }

		// @property (readonly, retain, nonatomic) NSString * restrictionsCode;
		[Export ("restrictionsCode", ArgumentSemantic.Retain)]
		string RestrictionsCode { get; }

		// @property (readonly, retain, nonatomic) NSString * restrictionCode;
		[Export ("restrictionCode", ArgumentSemantic.Retain)]
		string RestrictionCode { get; }

		// @property (readonly, retain, nonatomic) NSString * issueDate;
		[Export ("issueDate", ArgumentSemantic.Retain)]
		string IssueDate { get; }

		// @property (readonly, retain, nonatomic) NSString * fullName;
		[Export ("fullName", ArgumentSemantic.Retain)]
		string FullName { get; }

		// @property (readonly, retain, nonatomic) NSString * lastName;
		[Export ("lastName", ArgumentSemantic.Retain)]
		string LastName { get; }

		// @property (readonly, retain, nonatomic) NSString * firstName;
		[Export ("firstName", ArgumentSemantic.Retain)]
		string FirstName { get; }

		// @property (readonly, retain, nonatomic) NSString * middleName;
		[Export ("middleName", ArgumentSemantic.Retain)]
		string MiddleName { get; }

		// @property (readonly, retain, nonatomic) NSString * birthdate;
		[Export ("birthdate", ArgumentSemantic.Retain)]
		string Birthdate { get; }

		// @property (readonly, retain, nonatomic) NSString * nameSuffix;
		[Export ("nameSuffix", ArgumentSemantic.Retain)]
		string NameSuffix { get; }

		// @property (readonly, retain, nonatomic) NSString * namePrefix;
		[Export ("namePrefix", ArgumentSemantic.Retain)]
		string NamePrefix { get; }

		// @property (readonly, retain, nonatomic) NSString * address1;
		[Export ("address1", ArgumentSemantic.Retain)]
		string Address1 { get; }

		// @property (readonly, retain, nonatomic) NSString * address2;
		[Export ("address2", ArgumentSemantic.Retain)]
		string Address2 { get; }

		// @property (readonly, retain, nonatomic) NSString * city;
		[Export ("city", ArgumentSemantic.Retain)]
		string City { get; }

		// @property (retain, nonatomic) NSString * jurisdictionCode;
		[Export ("jurisdictionCode", ArgumentSemantic.Retain)]
		string JurisdictionCode { get; set; }

		// @property (readonly, retain, nonatomic) NSString * postalCode;
		[Export ("postalCode", ArgumentSemantic.Retain)]
		string PostalCode { get; }

		// @property (retain, nonatomic) NSString * country;
		[Export ("country", ArgumentSemantic.Retain)]
		string Country { get; set; }

		// @property (readonly, retain, nonatomic) NSString * gender;
		[Export ("gender", ArgumentSemantic.Retain)]
		string Gender { get; }

		// @property (readonly, retain, nonatomic) NSString * eyeColor;
		[Export ("eyeColor", ArgumentSemantic.Retain)]
		string EyeColor { get; }

		// @property (readonly, retain, nonatomic) NSString * height;
		[Export ("height", ArgumentSemantic.Retain)]
		string Height { get; }

		// @property (readonly, retain, nonatomic) NSString * weightLBS;
		[Export ("weightLBS", ArgumentSemantic.Retain)]
		string WeightLBS { get; }

		// @property (readonly, retain, nonatomic) NSString * weightKG;
		[Export ("weightKG", ArgumentSemantic.Retain)]
		string WeightKG { get; }

		// @property (readonly, retain, nonatomic) NSString * weight;
		[Export ("weight", ArgumentSemantic.Retain)]
		string Weight { get; }

		// @property (readonly, retain, nonatomic) NSString * hairColor;
		[Export ("hairColor", ArgumentSemantic.Retain)]
		string HairColor { get; }

		// @property (readonly, retain, nonatomic) NSString * race;
		[Export ("race", ArgumentSemantic.Retain)]
		string Race { get; }

		// -(NSArray *)availableFields;
		[Export ("availableFields")]
		//[Verify (MethodToProperty), Verify (StronglyTypedNSArray)]
		NSObject[] AvailableFields { get; }

		// -(NSString *)valueForField:(NSString *)field;
		[Export ("valueForField:")]
		string ValueForField (string field);

		// -(id)valueForDateField:(NSString *)field withFormat:(NSString *)dateFormat;
		[Export ("valueForDateField:withFormat:")]
		NSObject ValueForDateField (string field, string dateFormat);
	}

	// @interface Camera (DriverLicense)
	[Category]
	[BaseType (typeof(DriverLicense))]
	interface DriverLicense_Camera
	{
		// +(id)captureByCamera:(UIView *)camView hideSerialAlert:(BOOL)hideSerialAlert;
		[Static]
		[Export ("captureByCamera:hideSerialAlert:")]
		NSObject CaptureByCamera (UIView camView, bool hideSerialAlert);
	}
}
