﻿using System;
using System.Reflection;
using System.IO;
using Foundation;

using UIKit;
using DriverLicenseParser;

namespace parserTest
{
	public partial class ViewController : UIViewController
	{
		public ViewController (IntPtr handle) : base (handle)
		{
		}

		public override void ViewDidLoad ()
		{
			base.ViewDidLoad ();
			parseBtn.TouchUpInside += HandleTouchUpInsideParse;
			var assembly = Assembly.GetExecutingAssembly();
			var resourceName = "parserTest.dlpSerial.txt";
			string result = "";
			using (Stream stream = assembly.GetManifestResourceStream(resourceName))
			using (StreamReader reader = new StreamReader(stream))
			{
				result = reader.ReadToEnd();
			}

			NSUserDefaults.StandardUserDefaults.SetString(result, "DriverLicenseParserCurrentSerial"); 
			NSUserDefaults.StandardUserDefaults.Synchronize ();
			// Perform any additional setup after loading the view, typically from a nib.
		}

		public override void DidReceiveMemoryWarning ()
		{
			base.DidReceiveMemoryWarning ();
			// Release any cached data, images, etc that aren't in use.
		}

		private void HandleTouchUpInsideParse (object sender, EventArgs e)
		{
			DriverLicense parser = new DriverLicense();
			var assembly = Assembly.GetExecutingAssembly();
			var resourceName = "parserTest.testdl.txt";
			string result = "";
			using (Stream stream = assembly.GetManifestResourceStream(resourceName))
			using (StreamReader reader = new StreamReader(stream))
			{
				result = reader.ReadToEnd();
			}

			if (parser.ParseDLString (result, true) == false) {
				resultTextView.Text = @"fail";
				return;
			}
			resultTextView.Text = parser.Fields.Description;
		}
	}
}

